Subject: bug#65379: 29.1.50; isearch started through `isearch-resume' incorrectly moves point after failure

From: Jens Schmidt <[email-masked]>
Date: Sat, 19 Aug 2023 11:45:58 +0200

One of the more arcane features of isearch ... I do not actually
use that, but I modeled one of my personal isearch functions after
`isearch-resume´ and came across this issue.

emacs -Q

M-: (setq isearch-resume-in-command-history t) RET

Then execute:

  f                     ;; self-insert-command
  o                     ;; self-insert-command
  o                     ;; self-insert-command
  b                     ;; self-insert-command
  a                     ;; self-insert-command
  r                     ;; self-insert-command
  b                     ;; self-insert-command
  a                     ;; self-insert-command
  z                     ;; self-insert-command
  <return>              ;; newline
  C-<home>              ;; beginning-of-buffer
  C-s                   ;; isearch-forward
  f                     ;; isearch-printing-char
  o                     ;; isearch-printing-char
  o                     ;; isearch-printing-char
  b                     ;; isearch-printing-char
  a                     ;; isearch-printing-char
  r                     ;; isearch-printing-char
  b                     ;; isearch-printing-char
  a                     ;; isearch-printing-char
  z                     ;; isearch-printing-char
  <return>              ;; isearch-exit
  C-<home>              ;; beginning-of-buffer
  C-x <escape> <escape> ;; repeat-complex-command
  <return>              ;; read--expression-try-read
  C-s                   ;; isearch-repeat-forward

=> point jumps to bob and the complete buffer gets highlighted on the
   search failure after the `C-s'

I'm not an isearch expert, but I think the remedy should be to add a
call to `isearch-push-state' before the call to `isearch-update' in
function `isearch-resume':

diff --git a/lisp/isearch.el b/lisp/isearch.el
index 3d2bbda4975..14f335f4cea 100644
--- a/lisp/isearch.el
+++ b/lisp/isearch.el
@@ -4640,6 +4640,7 @@ isearch-resume
 	isearch-message message
 	isearch-case-fold-search case-fold)
   (isearch-search)
+  (isearch-push-state)
   (isearch-update))
 
At least that helps preventing the incorrect behavior, and most other
calls to `isearch-update' have a preceeding call to `isearch-push-state'
in isearch.el.  But that doesn't mean anything, of course, so somebody
else should review that.